Attribute VB_Name = "Module1"
Option Explicit
Private Declare Function RoundRect Lib "GDI32" _
(ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, _
 ByVal X2 As Long, ByVal Y2 As Long, _
 ByVal X3 As Long, ByVal Y3 As Long) _
   As Long
'NOTE: If you're into Regions as shapes, almost the
'same parameters can be passed to CreateRoundRectRgn

Public Sub PaintShapeObj(ByVal SpecialShape As Long, _
 MyShape As Shape, Destpic As Object)
'*********
' Paint Any Shape and its Properties
' with one *easy* call to RoundRect API (by Chris)
'*********
' DestPic = any object w/ DC (Device Content),
' like a Form, PictureBox, Printer (MemoryDC?)
''PS- You might want to Save and Restore the DC
''if you're using other graphic methods...
''...or set them B4 each call like this example?
'-------------------
' SpecialShape "SuperClasses" regular shapes
' SpecialShape = Shape you want (see below)
'  if no special shape, then
'ex:  PaintShapeObj Shape1.Shape, Shape1, Picture1
'  if special, then
'ex:  PaintShapeObj 8, Shape1, Picture1 'Disk Shape
'-Play w/ the corners to create your own unique shapes!
'NOTE----------------
' This code uses the Shape's size and coordinates,
' which some might consider a disadvantage.
' Pass those parameters instead?
' Passing a Shape seems more convenient, since
' other properties are being used too...
' there are many parameters here!
';) Try using a Hidden Shape instead.
'ex: Shape1.Visible = False ' or set at design
'    Shape1.Move 0, 0, Screen.Width, Screen.Height
'    PaintShapeObj vbShapeOval, Shape1, Me
'-------------------
''Note: Works when .BackStyle=Transparent
''"Opaque" setting is strange!?
''-but can be emulated w/dif props or 2 calls to PaintShapeObj

'map borderstyle to drawstyle
Dim MapStyle As Integer
MapStyle = MyShape.BorderStyle
If MapStyle <> vbBSInsideSolid Then '6
 If MapStyle <> vbTransparent Then '0
   MapStyle = MapStyle - 1
 Else
   MapStyle = vbInvisible '5
 End If
End If

' set ALL graphic properties
With Destpic
 .DrawStyle = MapStyle 'borderstyle
 .DrawMode = MyShape.DrawMode
 .FillStyle = MyShape.FillStyle
 .FillColor = MyShape.FillColor
 .ForeColor = MyShape.BorderColor
 .DrawWidth = MyShape.BorderWidth
End With

Dim ll As Long, tt As Long 'pixels
Dim ww As Long, hh As Long
Dim Cx As Long, Cy As Long ' CurvatureX, CurvatureY
ll = Destpic.ScaleX(MyShape.Left, vbTwips, vbPixels)
tt = Destpic.ScaleY(MyShape.Top, vbTwips, vbPixels)
ww = Destpic.ScaleX(MyShape.Width, vbTwips, vbPixels)
hh = Destpic.ScaleY(MyShape.Height, vbTwips, vbPixels)
'for later calculations
Dim leastSide As Long
If ww < hh Then
 leastSide = ww
Else
 leastSide = hh
End If
' square it out
Select Case MyShape.Shape
Case vbShapeSquare, vbShapeRoundedSquare, vbShapeCircle
  If ww > hh Then
   ll = ll + Fix((ww - hh) * 0.5)
   ww = hh
  Else
   tt = tt + Fix((hh - ww) * 0.5)
   hh = ww
  End If
End Select
'emulate shape corners
Select Case SpecialShape 'MyShape.Shape
Case vbShapeRectangle, vbShapeSquare
  Cx = 0: Cy = 0 'no corners
Case vbShapeCircle, vbShapeOval
  Cx = ww: Cy = hh 'fully rounded
Case vbShapeRoundedRectangle, vbShapeRoundedSquare
 '25% corners
 Cx = Fix(leastSide * 0.25)
 Cy = Cx
''special classes here!
Case 6 'Barrel (jar?)
 Cx = Fix(leastSide * 0.5)
 Cy = hh
Case 7 'Portal!
 Cx = Fix(hh * 0.8)
 Cy = Fix(ww * 0.8)
Case 8 'Disk (Can?)Cheese?
 Cx = ww
 Cy = Fix(leastSide * 0.5)
Case 9 'RoundER Rect
 Cx = Fix(leastSide * 0.6)
 Cy = Cx
'Case Else
'raise error?
' or something less drastic?
' :(don't worry, a rect will be painted:)
End Select

'paint with parameters
RoundRect Destpic.hdc, ll, tt, ww + ll, hh + tt, Cx, Cy

End Sub




